package util

import "io"

type multiWriteCloser struct {
	io.Writer
	io.Closer
}

func MultiWriteCloser(a io.Writer, b io.Writer) io.WriteCloser {
	aCloser, aOk := a.(io.Closer)
	bCloser, bOk := b.(io.Closer)
	if aOk && bOk {
		return multiWriteCloser{
			io.MultiWriter(a, b),
			MultiCloser(aCloser, bCloser),
		}
	} else if aOk {
		return multiWriteCloser{
			io.MultiWriter(a, b),
			aCloser,
		}
	} else if bOk {
		return multiWriteCloser{
			io.MultiWriter(a, b),
			bCloser,
		}
	} else {
		return multiWriteCloser{
			io.MultiWriter(a, b),
			nil,
		}
	}
}
